<?php
  include('include.php');

  $ip_id = $_GET['patient_record_id'];

  $sql = "SELECT (pd.id) patient_id, pd.patient_name, pd.gender, pd.blood, pd.dob, pd.mrd_no, DATE_FORMAT(opd.dateTime, '%d-%m-%Y %H:%i') admit_date, opd.nurse_charge, opd.bed_charge, opd.ad_amount, opd.bed_id, opd.doc_fee
          FROM patient_data pd
          JOIN ip_ob_entry_data opd ON opd.patient_id = pd.id
          WHERE opd.id='$ip_id'";

  $result = mysqli_query($conn, $sql);

  if($row = mysqli_fetch_assoc($result)){
    $patient_name = $row['patient_name'];
    $gender       = $row['gender'];
    $mrd          = $row['mrd_no'];
    $blood        = $row['blood'];
    $bed_id       = $row['bed_id'];

    $patient_id = $row['patient_id'];

    $doctor_charge = $row['doc_fee'];
    $dob = $row['dob'];
    $currentDate = new DateTime();
    $dateOfBirth = new DateTime($dob);    
    $age = $currentDate->diff($dateOfBirth)->y;

    $admit_date = $row['admit_date'];

    $nurse_charge = $row['nurse_charge'];
    $bed_charge = $row['bed_charge'];
    $advance_amount = $row['ad_amount'];
  }
?>
<!DOCTYPE html>
<html lang="zxx" dir="ltr" class="light">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <title>IPD Billing</title>
  <link rel="icon" type="image/png" href="<?php echo $main_path; ?>assets/images/logo/favicon.svg">
  <link rel="preconnect" href="https://fonts.googleapis.com/">
  <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;800&amp;display=swap"
    rel="stylesheet">


    <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- BEGIN: Theme CSS-->
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/rt-plugins.css">
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/app.css">
  <!-- End : Theme CSS -->

  <!-- Start : theme-store js -->
  <script src="<?php echo $main_path; ?>assets/js/store.js" sync></script>
  <!-- End : theme-store js -->
</head>

<style>
  input::-webkit-outer-spin-button,
  input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }

  .mandatory::after {
    content: "*";
    color: red;
    padding-left: 5px;
  }

  .table-td{
    text-align:center !important;
  }

  .table-th{
    text-align:center !important;
  }

  #ipd_id,#patient_name,#doctor,#admit_date,#discharge_date,#subtotal,#total_discount,#total_bill,#description{
      font-size:0.875rem !important;
      color:gray;
    }
    #ulDrop{
                  padding-left: 0;
                  margin-bottom: 0;
                  
                }
                #ulDrop a {
  text-decoration: none;
}

</style>

<body class=" font-inter dashcode-app" id="body_class">
  <main class="app-wrapper">
    <!-- BEGIN: Sidebar -->
    <!-- BEGIN: Sidebar -->
    <?php include('sidebar.php'); ?>
    <!-- End: Sidebar -->

    <div class="flex flex-col justify-between min-h-screen">
      <div>
        
        <!-- BEGIN: Header -->
        <?php include('nav.php'); ?>

        <div class="content-wrapper transition-all duration-150 xl:ltr:ml-[248px] xl:rtl:mr-[248px]"
          id="content_wrapper">
          <div class="page-content">
            <div id="content_layout">
              <!-- BEGIN: Breadcrumb -->

              <div class="grid xl:grid-cols-1 grid-cols-1 gap-6">
                <!-- Basic Inputs -->
                <div class="card">
                  <header class="card-header noborder d-flex justify-content-between">
                    <h4 class="card-title" style="margin-top:0.75rem; padding-left: 20px;">Add Investigation</h4>
                    <form action="investigation_history.php" method="get">
                        <input type="hidden" name="ip_id" value="<?php echo $ip_id; ?>">
                        <button type="submit" class="btn btn-primary me-3">History</button>
                    </form>
                   
                  </header>
                  <div class="card-body flex flex-col p-6">

                    <div style="display:flex;justify-content:space-between;width:100%;">                   
                    
                    </div>

                    <div class="card-body">
                      <div class="row">

                         <div class="card-body">
                            <div class="row ps-2">

                              <div class="col-lg-6 col-md-2 col-sm-5 col-4">
                                <p class="text1">Patient Name: <span class="text-primary ms-1"><?php echo $patient_name ?></span></p>
                                <p class="mt-2 text1">Gender: <span class="text-primary ms-5"><?php echo $gender ?></span></p>
                                <p class="mt-2 text1">Age: <span class="text-primary" style="margin-left: 70px"><?php echo $age ?></span></p>
                              </div>

                              <div class="col-6">
                                <p class="text1">MRD No: <span  class="text-primary ms-5"><?php echo $mrd ?></span></p>
                                <p class="mt-2 text1">Blood Group: <span  class="text-primary ms-3"><?php echo $blood ?></span></p>
                              </div>

                            </div>
                            
                            <br><br>

                          </div>
                      </div>

                      <div class="row" style="margin-top: -90px;">

                        <!-- <hr> -->
                
                        <div class="row mb-5">
                          <table class="divide-y divide-slate-100 dark:divide-slate-700 mt-5" style="width: 99%; margin-left: 20px;">
                              <thead class="bg-slate-200 dark:bg-slate-700">
                              
                                  <tr>
                                      <th scope="col" style="width:50px;padding-left:10px;padding-right:10px;" class="table-th"></th>
                                      <!-- <th scope="col"tyle="width:80px;" class="table-th">#</th> -->
                                      <th scope="col" class="table-th">Investigation Name</th>
                                      <th scope="col" class="table-th">Division Name</th>
                                      <!-- <th scope="col" class="table-th text-right">Payable Amount</th> -->
                                  </tr>
                              </thead>
                              <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="inves_records">
                              </tbody>
                          </table>
                        </div>
                        <hr>
                      </div>

                      <div class="modal fade" id="addves" tabindex="-1" role="dialog" aria-labelledby="addves"
                        aria-hidden="true">
                        <div class="modal-dialog modal-lg" role="document">
                          <div class="modal-content">
                            <div class="modal-body ">

                              <div class="d-flex justify-content-between mt-2">
                                <div class="col-12">
                                  <div class="input-area">
                                    <div class="relative d-flex gap-2">
                                      <iconify-icon icon="material-symbols:search" class="mt-2" style="font-size: 24px;">
                                      </iconify-icon>
                                      <input type="text" id="search" class="form-control" placeholder="Search by Service">
                                    </div>
                                  </div>
                                </div>
                                <!-- <div>
                                  <button class="btn btn-sm btn-primary" data-toggle="modal" data-target="#addService">
                                    Add Service
                                  </button>
                                </div> -->
                              </div>

                              <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700 mt-4"
                                id="color-status">
                                <thead class="bg-slate-200 dark:bg-slate-700">
                                  <tr>
                                    <th scope="col" class="table-th" style="width:50px;">
                                      #
                                    </th>
                                    <th scope="col" class=" table-th ">
                                      Investigation
                                    </th>
                                    <th scope="col" class=" table-th ">
                                      Division
                                    </th>
                                    <!-- <th scope="col" class=" table-th ">
                                      Quantity
                                    </th> -->
                                    <!-- <th scope="col" class=" table-th text-right ">
                                      Payable Amount
                                    </th> -->
                                  </tr>
                                </thead>
                                <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="append_inves">
                                </tbody>
                              </table>
                            </div>
                            <div style="display:flex;justify-content:end;">
                              
                            <button class="btn btn-sm btn-primary mt-4 m-3" id="cancel_inves" data-bs-dismiss="modal">
                                <div class="d-flex">
                                    <!-- <iconify-icon icon="mdi:cancel" style="font-size:15px;"></iconify-icon> -->
                                    <span class="ms-1">Cancel</span>
                                </div>
                            </button>

                              <button class="btn btn-sm btn-success mt-4 m-3" id="submit_inves">
                                <div class="d-flex">
                                  <!-- <iconify-icon icon="mdi:tick" style="font-size:15px;">
                                  </iconify-icon>  -->
                                  <span class="ms-1">Submit</span>
                                </div>
                              </button>
                            </div>
                          </div>
                        </div>
                      </div>

                      <div style="display:flex;justify-content:end;" class="mt-3">
                        <button class="btn btn-sm btn-info text-white mt-4 me-1" data-bs-toggle="modal" data-bs-target="#addves">
                          Add Investigation
                        </button>
                      </div>
                     
                    </div>

                    <hr>
                  
                    <div class="row">

                      <div class="col-4">
                       
                      </div>

                      <div class="col-2 mb-4"></div>

                      <div class="col-6">
                        <div class="row">
                          <!-- <div class="col-6 mb-3 d-flex justify-content-end align-items-center">
                            Total
                          </div>
                          <div class="col-6 mb-3">
                            <input id="subtotal" type="number" class="form-control text-right" placeholder="Sub Total" readonly>
                          </div> -->
                          <div class="col-6 mb-3 d-flex justify-content-end align-items-center d-none">
                            Paid Amount
                          </div>
                          <div class="col-6 mb-3 d-none">
                          <input id="advance" type="number" class="form-control text-right" placeholder="Advance" value='<?php echo $advance_amount; ?>' readonly>
                          </div>
                          <!-- <div class="col-6 mb-3 d-flex justify-content-end align-items-center d-none">
                            Payable Amount
                          </div>
                          <div class="col-6 mb-3 d-none">
                            <input id="total_bill"  class="form-control text-right" placeholder="Total Bill" readonly>
                          </div> -->
                        </div>
                      </div>
                     
                      <div class="col-12 mt-5">
                        <div class="d-flex justify-content-end">
                          <button class="btn btn-sm btn-primary me-3 mb-4" id="gen_bill">Add</button>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

     
     
  </main>
  <!-- scripts -->

  <script src="<?php echo $main_path; ?>assets/js/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/rt-plugins.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/app.js"></script>

  <!-- Bootstrap CSS -->

  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- Bootstrap JS and Popper.js -->
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>
<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>


<script src="<?php echo $main_path; ?>assets/toastr/build/toastr.min.js"></script> 

<link rel="stylesheet" href="<?php echo $main_path; ?>assets/toastr/build/toastr.min.css" />
<script>
  function viewHistory() {
      // Implement the logic to view history
      alert('View history clicked');
    }
    
    var bc = 0;

    $(document).ready(function () {

    //   $('#search').on('keyup', function() {
    //     var value = $(this).val().toLowerCase();
    //     var hasVisibleRows = false;

    //     $('#append_inves tr').filter(function() {
    //         if ($(this).hasClass('no-data-found')) return; // Skip the no-data-found row

    //         var isVisible = $(this).text().toLowerCase().indexOf(value) > -1;
    //         $(this).toggle(isVisible);
    //         if (isVisible) hasVisibleRows = true;
    //     });

    //     // Toggle the no-data-found row based on visibility of other rows
    //     if (hasVisibleRows) {
    //         $('.no-data-found').hide();
    //     } else {
    //         $('.no-data-found').show();
    //     }
    // });

    $("#search").on("keyup", function() {
    var value = $(this).val().toLowerCase();
    var visibleRows = 0;
    
    $("#append_inves tr").filter(function() {
        var match = $(this).text().toLowerCase().indexOf(value) > -1;
        $(this).toggle(match);
        if (match) {
            visibleRows++;
        }
    });

    // Check if any rows are visible
    if (visibleRows === 0) {
        // Show no data available message
        if ($("#no-data").length === 0) {
            $("#append_inves").append('<tr id="no-data"><td class="text-center" colspan="8" class="no-data">No data available</td></tr>');
        }
    } else {
        // Remove no data available message
        $("#no-data").remove();
    }
});



      function fetchData() {

        $.ajax({
          url: '../ajax/scan_division_list.php',
          type: 'get', 
          success: function (response) {
            var result = JSON.parse(response);
            if (result.status == 'Success') {
              inves_row = result.data;
              // filterScan('');
              updateInvesTable(inves_row);
            }
          },
          error: function (error) {
            console.error('Error fetching data:', error);
          }
        });
      } fetchData();

      var selected_inves_ids = [];
      $('.id-check input[type="checkbox"]').change(function() {
        var div_id = $(this).data('id');
        
        if ($(this).is(':checked')) {
          selected_inves_ids.push(div_id);
        } else {
          selected_inves_ids = selected_inves_ids.filter(id => id !== div_id);
        }
      });

      function populateSelectedInvesIds() {
        $('.id-check input[type="checkbox"]:checked').each(function() {
          var div_id = $(this).data('id');
          selected_inves_ids.push(div_id);
        });
      } populateSelectedInvesIds();

      function updateInvesTable(data){
        var append_inves = $('#append_inves');
        var checkInvesHtml = '';

        data.map(function (item){
          var isInvesChecked = selected_inves_ids.includes(parseInt(item.id));
        
          checkInvesHtml += `<tr>
                              <td scope="col" class="table-td">
                                  <div class="input-area">
                                      <div class="relative">
                                          <input class="form-check inves_checkbox" type="checkbox" data-id='${item.id}' ${isInvesChecked ? 'checked' : ''}>
                                      </div>
                                  </div>
                              </td>
                              <td scope="col" class="table-td inves_scan_name">${item.scan_name}</td>
                              <td scope="col" class="table-td inves_scancat_name">${item.scan_cat_name}</td>
                             
                            </tr>`;
        })
        append_inves.append(checkInvesHtml);
      }

      // $(document).on('click', '.increase-btn', function() {
      //     var inputField = $(this).siblings('.quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     inputField.val(currentValue + 1).trigger('change');
      // });

      // $(document).on('click', '.decrease-btn', function() {
      //     var inputField = $(this).siblings('.quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     if (currentValue > 1) {
      //         inputField.val(currentValue - 1).trigger('change');
      //     }
      // });

      // $(document).on('change', '.quantity-input', function() {
      //   var itemId = $(this).data('id');
      //   var newQuantity = parseInt($(this).val());
        
      //   var priceCell = $(this).closest('tr').find('.inves_amount');
      //   var og_price = parseFloat(priceCell.data('price'));

      //   var totalAmount = newQuantity * og_price;

      //   priceCell.text(totalAmount.toFixed(2));
      // });

      var checkedModalInves = [];
      $('#submit_inves').on('click', function(){

        checkedModalInves.length = 0;
        $('.inves_checkbox:checked').each(function() {
            var id = $(this).data('id');
            var inves_scan_name = $(this).closest('tr').find('.inves_scan_name').text();
            var inves_scancat_name = $(this).closest('tr').find('.inves_scancat_name').text();
            // var inves_qty = $(this).closest('tr').find('.quantity-input').val();
            // var inves_amount = parseFloat($(this).closest('tr').find('.inves_amount').text());

            checkedModalInves.push({
                id: id,
                scan_name: inves_scan_name,
                scan_cat_name: inves_scancat_name
            });
            console.log(checkedModalInves);
        });

        var patient_records = $('#inves_records');
        patient_records.html('');
        checkedModalInves.forEach(function(division, index) {
            index += 0
            var invesHtml = `<tr class="inves_data">
                            <td scope="col" class="table-td id-check" style="display:flex;justify-content:end;padding-left:10px;padding-right:10px;" >
                              <input type="checkbox" data-id="${division.id}" data-amount="${division.amount}" class="form-check-input" checked disabled>
                            </td>
                            <td scope="col" class="table-td scan_name">${division.scan_name}</td>
                            <td scope="col" class="table-td division_name">${division.scan_cat_name}</td>
                        </tr>`;
            patient_records.append(invesHtml);
        });

        subTotal();
        if(checkedModalInves.length == 0){
          toastr.error("Select any investigation before submitting");
          return;
        }

        $('#cancel_inves').click();

      })


      // $(document).on('click', '.increase-btn', function() {
      //     var inputField = $(this).siblings('.ser-quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     inputField.val(currentValue + 1).trigger('change');
      // });

      // $(document).on('click', '.decrease-btn', function() {
      //     var inputField = $(this).siblings('.ser-quantity-input');
      //     var currentValue = parseInt(inputField.val());
      //     if (currentValue > 1) {
      //         inputField.val(currentValue - 1).trigger('change');
      //     }
      // });



      $('#submit').on('click', function () {
        // var checkedServices = [];

        var totalAmount = 0;

        subTotal();
        $('#cancel_btn').click();
    });

      $('#total_discount').on('input', function () {
          subTotal();
      });

      function subTotal() {
        // var serviceAmounts = $('.service_amount');
        var subTotal = 0;

        let inves_amount = 0;
        $('.division_price').each(function(){
          inves_amount = parseFloat($(this).text());
          subTotal += inves_amount;
        })

        var subtotalElement = $('#subtotal');
        subtotalElement.val(subTotal.toFixed(2));

        var advance = parseFloat($('#advance').val()) || 0;
        var less = parseFloat($('#total_discount').val()) || 0;

        var total = (subTotal - advance - less).toFixed(2);

        if (parseFloat(less) > parseFloat(subTotal)) {
            toastr.error('Less cannot exceed the total amount.');
            less = parseFloat(subTotal);
            total = '0.00';

        }
        $('#total_bill').val(total);
      }
      subTotal();

        $('#gen_bill').click(function () {

          var patient_id = <?php echo $patient_id; ?>;
          var patient_record_id = <?php echo $ip_id ?>;
          var total = $('#total_bill').val();
          var services = [];

          $('#patient_records .s_data').each(function () {
              var s_id = $(this).data('id');
              var service_name = $(this).find(".service_name").text().trim();
              // var qty = $(this).find(".s_qty").text().trim();
              // var service_amount = $(this).find(".service_amount").text().trim();

              var service_row = {
                  s_id: s_id,
                  service_name: service_name,
                  qty: qty,
                  service_amount: service_amount
              };
              services.push(service_row);
          });

          var checkedCheckboxes = $('.id-check input[type="checkbox"]:checked');
          var checkedCheckboxesData = [];
          
          checkedCheckboxes.each(function(index, checkbox) {
              var id = $(checkbox).data('id');
              var d_qty = parseInt($(checkbox).closest('tr').find('.i_qty').text());
              var amount = $(checkbox).data('amount');

              checkedCheckboxesData.push({ 
                division_id: id,
                d_qty: d_qty,
                amount: amount
              });
          });

          if (checkedCheckboxesData.length == 0) {
              toastr.error('Select Investigation');
          } 
          else {
              var fd = new FormData();

              fd.append('patient_id', patient_id);
              fd.append('patient_record_id', patient_record_id);
              fd.append('total', total);

              fd.append('services', JSON.stringify(services));

              fd.append('division_id', JSON.stringify(checkedCheckboxesData));

              fd.append('created_by', '<?php echo $ward_user_id; ?>');
              fd.append('user_type', '<?php echo $user_type; ?>');

              $.ajax({
                url: 'ajax/ip/add_serv_inves.php',
                type: 'post',
                contentType: false,
                processData: false,
                data: fd,
                success:function(response){
                  var result = JSON.parse(response);
                  if(result.status == 'Success'){
                    toastr.success('Investigation added successfully');
                    setTimeout(function() {
                        window.location.href = 'ip_records.php';
                    }, 1500); 
                  }
                }

              })
          }
        });
        if ($('#inves_records tr').length === 0) {
            $('#inves_records').append(`<tr>
                                      <td colspan="4" class="table-td">No data available in table</td>
                                    </tr>`);
        }

       

      });
</script>
</body>

</html>