<?php 
    require_once '../../../datab.php';

    $patient_drip_id = mysqli_real_escape_string($conn, $_POST['patient_drip_id']);
    $patient_id = mysqli_real_escape_string($conn, $_POST['patient_id']);

    $checkFinished = mysqli_query($conn, "SELECT * FROM patient_drip WHERE patient_id='$patient_id' AND `status` = 'started' ");

    if(mysqli_num_rows($checkFinished) > 0){
        $res['status'] = 'Failed';
        $res['message'] = 'Patient Drip still unfinished';
        echo json_encode($res);
        exit;
    }

    $getRateAndDosage = mysqli_query($conn, "SELECT pd.drip_id, pd.rate, tdp.dosage
                                            FROM patient_drip pd
                                            JOIN tablet_dosage_price tdp ON tdp.id = pd.drip_id
                                            WHERE pd.id = '$patient_drip_id'");

    if ($getRateAndDosage && mysqli_num_rows($getRateAndDosage) > 0) {
        $row = mysqli_fetch_assoc($getRateAndDosage);

        $rate = floatval($row['rate']);
        $dosage = $row['dosage'];

        preg_match('/\d+/', $dosage, $matches);
        $dosage_in_ml = isset($matches[0]) ? floatval($matches[0]) : 0;

        if ($dosage_in_ml > 0 && $rate > 0) {
            $time_in_hours = $dosage_in_ml / $rate;

            $time_in_seconds = $time_in_hours * 3600;

            $start_time = new DateTime();

            $end_time = clone $start_time;
            $end_time->modify("+$time_in_seconds seconds");

            $formatted_start_time = $start_time->format('H:i:s');
            $formatted_end_time = $end_time->format('H:i:s');

            $update_patient_drip = "UPDATE patient_drip 
                                    SET `start_time` = '$formatted_start_time', 
                                        `end_time` = '$formatted_end_time', 
                                        `status` = 'started' 
                                    WHERE id = '$patient_drip_id'";

            if (mysqli_query($conn, $update_patient_drip)) {
                echo json_encode(['status' => 'Success', 'message' => 'Drip started successfully']);
            } else {
                echo json_encode(['status' => 'Error', 'message' => 'Error updating data: ' . mysqli_error($conn)]);
            }
        } else {
            echo json_encode(['status' => 'Error', 'message' => 'Invalid dosage or rate.']);
        }
    } else {
        echo json_encode(['status' => 'Error', 'message' => 'Failed to fetch drip details.']);
    }
?>
