<?php
    // session_start();
    // $floor_id = $_SESSION['floor_id'];
    require_once '../../../datab.php';
    $res = [];

    // Get the current page from the frontend (default is page 1)
    $current_page = isset($_GET['pg_no']) ? (int)$_GET['pg_no'] : 1;
    $limit = 10; // Number of records per page
    $offset = ($current_page - 1) * $limit; // Calculate the offset

    // First, get the total number of records (without pagination)
    $sql_total = "
        SELECT COUNT(*) AS total 
        FROM op_entry_data
        INNER JOIN patient_data ON patient_data.id = op_entry_data.patient_id
        INNER JOIN unassigned_patients ON op_entry_data.id = unassigned_patients.patient_record_id
        INNER JOIN doctor_data ON doctor_data.id = op_entry_data.doctor_id
        WHERE unassigned_patients.transfer_status = 'unassigned'
    ";

    $total_result = mysqli_query($conn, $sql_total);
    $total_row = mysqli_fetch_assoc($total_result);
    $total_count = (int) $total_row['total']; // Total number of records

    // Calculate total pages
    $total_pages = ceil($total_count / $limit);

    // Fetch paginated records
    $sql = "
        SELECT 
            op_entry_data.*, 
            patient_data.*, 
            op_entry_data.id AS op_id, 
            op_entry_data.status AS patient_status, 
            unassigned_patients.transfer_to, 
            DATE_FORMAT(op_entry_data.dateTime, '%Y-%m-%d %H:%i:%s') AS created_on, 
            unassigned_patients.transfer_status, 
            doctor_data.doctor_name 
        FROM 
            op_entry_data
        INNER JOIN 
            patient_data ON patient_data.id = op_entry_data.patient_id
        INNER JOIN 
            unassigned_patients ON op_entry_data.id = unassigned_patients.patient_record_id
        INNER JOIN 
            doctor_data ON doctor_data.id = op_entry_data.doctor_id
        WHERE 
            unassigned_patients.transfer_status = 'unassigned'
        LIMIT $limit OFFSET $offset
    ";

    if ($result = mysqli_query($conn, $sql)) {
        $data = [];
        while ($row = mysqli_fetch_assoc($result)) {
            $data[] = $row;
        }
        $res['data'] = $data;
        $res['status'] = 'Success';
        $res['remarks'] = 'Data sent';
        $res['total_count'] = $total_count;  // Total number of rows
        $res['total_pages'] = $total_pages;  // Total number of pages
        $res['current_page'] = $current_page; // Current page number
    } else {
        $res['status'] = 'Error';
        $res['remarks'] = 'Error in backend: ' . mysqli_error($conn);
    }

    echo json_encode($res);
?>
