<?php
    require_once '../../../datab.php';
    $res = [];

    // Check if patient_record_id and type are provided in POST data
    if (isset($_POST['patient_record_id']) && isset($_POST['type'])) {
        $patientRecordId = mysqli_real_escape_string($conn, $_POST['patient_record_id']);
        $type = mysqli_real_escape_string($conn, $_POST['type']);

        // Determine the table to query based on type
        if ($type === 'ip') {
            $table = 'ip_medications_items';
        } elseif ($type === 'ob') {
            $table = 'ob_medications_items';
        } else {
            $res['status'] = 'Error';
            $res['remarks'] = 'Invalid type specified';
            echo json_encode($res);
            exit;
        }

        $sql = "
            SELECT $table.*, DATE_FORMAT($table.dateTime, '%d-%b-%Y %h:%i %p') AS op_date,
            (dd.id) doc_id, dd.doctor_name 
            FROM $table 
            LEFT JOIN doctor_data dd ON $table.created_by = dd.id
            WHERE patient_record_id = '$patientRecordId'
        ";
        $result = mysqli_query($conn, $sql);
        $quantity = 0;
        if ($result) {
            $data = [];
            while ($row = mysqli_fetch_assoc($result)) {
                $duration = $row['duration'];
                $frequency = $row['frequency'];
        
                // Calculate quantity
                $frequency_parts = explode('-', $frequency);
                $total_doses_per_day = 0;
        
                foreach ($frequency_parts as $part) {
                    if (strpos($part, '/') !== false) {
                        // Handle fraction
                        list($numerator, $denominator) = explode('/', $part);
                        $total_doses_per_day += $numerator / $denominator;
                    } else {
                        $total_doses_per_day += (float) $part;
                    }
                }
        
                $quantity = $total_doses_per_day * $duration;
                $row['quantity'] = $quantity; // Add quantity to the row data
        
                $data[] = $row;
            }
            $res['data'] = $data;
            $res['status'] = 'Success';
            $res['remarks'] = 'Data retrieved successfully';
        } else {
            $res['status'] = 'Failed';
            $res['remarks'] = 'Query error: ' . mysqli_error($conn);
        }
    } else {
        $res['status'] = 'Error';
        $res['remarks'] = 'Patient record ID and type are required';
    }

    echo json_encode($res);
?>
