<?php
require_once '../../../datab.php'; 

$response = [];

if (
    isset($_POST['patient_id']) &&
    isset($_POST['patient_name']) &&
    isset($_POST['drip_id']) &&
    isset($_POST['dosage']) &&
    isset($_POST['duration'])
) {
    $patient_id = mysqli_real_escape_string($conn, $_POST['patient_id']);
    $patient_name = mysqli_real_escape_string($conn, $_POST['patient_name']);
    $drip_id = mysqli_real_escape_string($conn, $_POST['drip_id']);
    $dosage_id = mysqli_real_escape_string($conn, $_POST['dosage']); 
    $duration = mysqli_real_escape_string($conn, $_POST['duration']); 

    // Get the current time as start_time
    $start_time = date('H:i:s');

    // Calculate end_time using start_time + duration
    $start_timestamp = strtotime($start_time);
    $duration_parts = explode(':', $duration);
    $duration_seconds = intval($duration_parts[0]) * 3600 + intval($duration_parts[1]) * 60 + intval($duration_parts[2]);
    $end_timestamp = $start_timestamp + $duration_seconds;
    $end_time = date('H:i:s', $end_timestamp);

    // Insert data into patient_drip table
    $created_at = date('Y-m-d H:i:s');
    $status = 'active'; // Set status to active

    $query = "INSERT INTO patient_drip (`patient_id`, `drip_id`, `start_time`, `end_time`, `created_at`, `status`, `dosage`)
              VALUES ('$patient_id', '$drip_id', '$start_time', '$end_time', '$created_at', '$status', '$dosage_id')";

    if (mysqli_query($conn, $query)) {
        $response['status'] = 'Success';
        $response['message'] = 'Drip created successfully';
        $response['data'] = [
            'patient_id' => $patient_id,
            'drip_id' => $drip_id,
            'start_time' => $start_time,
            'end_time' => $end_time,
            'created_at' => $created_at,
            'status' => $status,
            'dosage_id' => $dosage_id // Include dosage_id in the response
        ];
    } else {
        $response['status'] = 'Error';
        $response['message'] = 'Failed to create drip: ' . mysqli_error($conn);
    }
} else {
    $response['status'] = 'Error';
    $response['message'] = 'Missing required parameters';
}

header('Content-Type: application/json');
echo json_encode($response);
?>
