<?php
require_once '../../../datab.php';
$res = [];

if (isset($_POST['drip_id'])) {
    $drip_id = intval($_POST['drip_id']);

    // Query to fetch dosage details of the selected drips
    $sql = mysqli_query($conn, "
        SELECT tablet_dosage_price.dosage, tablet_dosage_price.price, tablet_dosage_price.id, tablet_dosage_price.purchase_rate
        FROM tablet_dosage_price
        WHERE tablet_dosage_price.tablet_id = $drip_id
    ");

    if ($sql) {
        $data = [];
        while ($row = mysqli_fetch_assoc($sql)) {
            // Extract numeric value from dosage
            preg_match('/\d+/', $row['dosage'], $matches);
            $dosage = isset($matches[0]) ? floatval($matches[0]) : 0;
            $purchase_rate = floatval($row['purchase_rate']);

            // Calculate the duration in minutes
            $duration_minutes = ($dosage / $purchase_rate) * 60;

            // Convert the duration to a time format (hours, minutes, and seconds)
            $hours = floor($duration_minutes / 60);
            $minutes = floor($duration_minutes % 60);
            $seconds = round(($duration_minutes - floor($duration_minutes)) * 60);
            $end_time = sprintf('%02d:%02d:%02d', $hours, $minutes, $seconds);

            // Add the calculated end time to the row data
            $row['end_time'] = $end_time;

            $data[] = $row;
        }
        $res = ['status' => 'Success', 'data' => $data];
    } else {
        $res = ['status' => 'Error', 'message' => 'Failed to fetch dosage details'];
    }
} else {
    $res = ['status' => 'Error', 'message' => 'Drip ID not provided'];
}

echo json_encode($res);
?>
