<?php
require_once '../../../datab.php';
$res = [];

// Query to fetch all inventory data along with the corresponding tablet names
$sql = mysqli_query($conn, "SELECT iw.medicine_id,iw.dosage_id,iw.quantity, td.tablet_name, td.type, tdp.dosage, tdp.price, td.company_id, mcd.company_name,
    (iw.quantity*tdp.price) As stock_value
    FROM inventory_ward iw
    JOIN tablet_data td ON iw.medicine_id = td.id
    JOIN tablet_dosage_price tdp ON iw.medicine_id = tdp.tablet_id AND iw.dosage_id = tdp.id
    JOIN medicine_company_data mcd ON td.company_id = mcd.id");

if ($sql) {
    $data = [];
    while ($row = mysqli_fetch_assoc($sql)) {
        $data[] = $row;
    }
    $res = ['status' => 'Success', 'data' => $data];
} else {
    $res = ['status' => 'Error', 'message' => 'Failed to fetch medicine data'];
}

echo json_encode($res);
?>
