<?php

require_once '../../../datab.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    
    $requestData = json_decode($_POST['requestData'], true);

    if (!$requestData || !is_array($requestData)) {
        echo json_encode(array('status' => 'Error', 'message' => 'Invalid requestData format.'));
        exit;
    }

    $sqlBatch = "INSERT INTO request_ward_batch (date, requestedBy, order_no)
                 VALUES (NOW(), 'Ward', 'ward 01')";

    if ($conn->query($sqlBatch) === TRUE) {
        $batchId = $conn->insert_id;
    } else {
        echo json_encode(array('status' => 'Error', 'message' => 'Error creating request batch: ' . $conn->error));
        exit;
    }

    $stmt = $conn->prepare("INSERT INTO medicine_requests (requestBatchid, tablet_name, dosage, description, created_at, count, type) 
                            VALUES (?, ?, ?, ?, current_timestamp(), ?, ?)");

    if (!$stmt) {
        echo json_encode(array('status' => 'Error', 'message' => 'Failed to prepare statement: ' . $conn->error));
        exit;
    }

    foreach ($requestData['medicines'] as $medicine) {
        $tabletName = $medicine['tabletName'];
        $dosage = $medicine['dosage'];
        $description = $medicine['description'];
        $count = $medicine['count'];
        $type = $medicine['type'];
        // $deadline = $medicine['deadline'];

        $stmt->bind_param('isssis', $batchId, $tabletName, $dosage, $description, $count, $type);

        if (!$stmt->execute()) {
            echo json_encode(array('status' => 'Error', 'message' => 'Failed to insert medicine request data: ' . $stmt->error));
            exit;
        }
    }

    $stmt->close();
    echo json_encode(array('status' => 'Success', 'message' => 'Request created successfully', 'batch_id' => $batchId));

} else {
    echo json_encode(array('status' => 'Error', 'message' => 'Method not allowed.'));
}

$conn->close();
?>
