<?php
include('include.php');

$ip_id = $_GET['patient_record_id'];

// Handle form submission
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $patient_id = $_POST['patient_id'];
    $mrd_no = $_POST['mrd_no'];
    $category = 0;
    $comment = $_POST['comment'];
    $created_at = date('Y-m-d H:i:s');

    // Prepare SQL statement with prepared statement
    $sql_insert = "INSERT INTO drip_comment (mrd_no, patient_id, category, comment, created_at)
               VALUES (?, ?, ?, ?, ?)";
$stmt = mysqli_prepare($conn, $sql_insert);
mysqli_stmt_bind_param($stmt, 'sssss', $mrd_no, $patient_id, $category, $comment, $created_at);

if (mysqli_stmt_execute($stmt)) {
    echo json_encode(['status' => 'success']);
} else {
    echo json_encode(['status' => 'error', 'error' => mysqli_error($conn)]);
}
exit;
}

// Fetch patient details
$sql = "SELECT pd.id as patient_id, pd.patient_name, pd.gender, pd.blood, pd.dob, pd.mrd_no, 
               DATE_FORMAT(opd.dateTime, '%d-%m-%Y %H:%i') as admit_date, 
               opd.nurse_charge, opd.bed_charge, opd.ad_amount, opd.bed_id, opd.doc_fee
        FROM patient_data pd
        JOIN ip_ob_entry_data opd ON opd.patient_id = pd.id
        WHERE opd.id='$ip_id'";

$result = mysqli_query($conn, $sql);

if ($row = mysqli_fetch_assoc($result)) {
    $patient_name = $row['patient_name'];
    $gender = $row['gender'];
    $mrd_no = $row['mrd_no']; // Ensure this value is correctly fetched
    $blood = $row['blood'];
    $bed_id = $row['bed_id'];
    $patient_id = $row['patient_id'];
    $doctor_charge = $row['doc_fee'];
    $dob = $row['dob'];
    $currentDate = new DateTime();
    $dateOfBirth = new DateTime($dob);    
    $age = $currentDate->diff($dateOfBirth)->y;
    $admit_date = $row['admit_date'];
    $nurse_charge = $row['nurse_charge'];
    $bed_charge = $row['bed_charge'];
    $advance_amount = $row['ad_amount'];
}

// Fetch comments
$sql_comments = "SELECT category, comment, DATE_FORMAT(created_at, '%d-%m-%Y %H:%i') as created_at 
                 FROM drip_comment 
                 WHERE patient_id='$patient_id' 
                 ORDER BY created_at DESC";
$comments_result = mysqli_query($conn, $sql_comments);
$comments = [];
while ($comment_row = mysqli_fetch_assoc($comments_result)) {
    $comments[] = $comment_row;
}
?>


<!DOCTYPE html>
<html lang="zxx" dir="ltr" class="light">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <title>IPD Billing</title>
  <link rel="icon" type="image/png" href="<?php echo $main_path; ?>assets/images/logo/favicon.svg">
  <link rel="preconnect" href="https://fonts.googleapis.com/">
  <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;800&amp;display=swap"
    rel="stylesheet">


    <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- BEGIN: Theme CSS-->
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/rt-plugins.css">
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/app.css">
  <!-- End : Theme CSS -->

  <!-- Start : theme-store js -->
  <script src="<?php echo $main_path; ?>assets/js/store.js" sync></script>
  <!-- End : theme-store js -->
</head>

<style>
  input::-webkit-outer-spin-button,
  input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }

  .mandatory::after {
    content: "*";
    color: red;
    padding-left: 5px;
  }

  .table-td{
    text-align:center !important;
  }

  .table-th{
    text-align:center !important;
  }
  .patient-info{
    padding: 20px;
    display: flex;
    flex-direction: row;
    font-size: 18px;
    font-weight: bold;
  }
  .mrd-no{
    margin-right: 280px;
  }
  /* .bed-no{
    margin-right: 240px;
  } */
  .input-group{
    
    margin-bottom: 10px;
  }
  .form-label{
    margin-bottom: -10px;
  }
  .chat{
    margin-right: -20px;
  }
  .chat-box {
    height: 200px;
    border: 1px solid lightgray;
    width: 1130px;
    border-radius: 15px;
    padding: 10px 20px 10px 20px;
    background-color: lightgray;
    margin-top: 30px;
    margin-left: 20px;
  }
  #category{
    margin-bottom: 2px;
  }
  #dateTime{
    margin-bottom: 2px;
  }

  .line{
    color: gray;
  }
  .col-two h6{
    margin-top: -12px;
  }
  .font-weight-bold {
    font-weight: bold;
}
.colon {
    margin-left: 25px;
    margin-right: 2px;
}
  
  #ipd_id,#patient_name,#doctor,#admit_date,#discharge_date,#subtotal,#total_discount,#total_bill,#description{
      font-size:0.875rem !important;
      color:gray;
    }

.chat-box {
    max-height: 200px; 
    width: 970px;/* Set a max height for scrollability */
    overflow-y: auto; /* Enable vertical scrolling */
    border: 1px solid lightgray; /* Optional: Add border */
    border-radius: 10px; /* Optional: Add border radius */
    padding: 10px; /* Optional: Add padding */
    background-color: #f9f9f9; /* Optional: Add background color */
}

/* Style adjustments for individual comments */
.comment {
    margin-bottom: 20px; /* Optional: Add margin between comments */
    padding: 10px; /* Optional: Add padding */
    border-radius: 8px; /* Optional: Add border radius */
}

.col-one, .col-two {
    /* Optional: Add styles for columns */
}
#ulDrop{
                  padding-left: 0;
                  margin-bottom: 0;
                }
                #ulDrop a{
                  text-decoration: none;
                }

  .row>* {
    flex-shrink: 0;
    width: 100%;
    max-width: 98% !important;
    padding-right: calc(var(--bs-gutter-x)* 1.5);
    padding-left: calc(var(--bs-gutter-x)* 1.3) !important;
    margin-top: var(--bs-gutter-y);
}  

</style>

<body class=" font-inter dashcode-app" id="body_class">
  <!-- [if IE]> <p class="browserupgrade"> You are using an <strong>outdated</strong> browser. Please <a href="https://browsehappy.com/">upgrade your browser</a> to improve your experience and security. </p> <![endif] -->
  <main class="app-wrapper">
    <!-- BEGIN: Sidebar -->
    <!-- BEGIN: Sidebar -->
    <?php include('sidebar.php'); ?>
    <!-- End: Sidebar -->
    <!-- End: Sidebar -->
    <!-- BEGIN: Settings -->

    <!-- BEGIN: Settings -->
    <!-- Settings Toggle Button -->

    <!-- END: Settings -->

    <!-- End: Settings -->
    <div class="flex flex-col justify-between min-h-screen">
      <div>
        
        <!-- BEGIN: Header -->
        <!-- BEGIN: Header -->
        <?php include('nav.php'); ?>

        <!-- END: Search Modal -->
        <!-- END: Header -->
        <!-- END: Header -->
        <div class="content-wrapper transition-all duration-150 xl:ltr:ml-[248px] xl:rtl:mr-[248px]"
          id="content_wrapper">
          <div class="page-content">
            <div id="content_layout">
              <!-- BEGIN: Breadcrumb -->

              <!-- END: BreadCrumb -->
              <div class="grid xl:grid-cols-1 grid-cols-1 gap-6">
                <!-- Basic Inputs -->
                <div class="card">
                  <header class="card-header noborder d-flex justify-content-between">
                  
                  <div class="container">
                    <div class="row">
                      
                      <div class="patient-info">
                      <div class="col-6">
                        <div class="mrd-no text-start" style="font-size: 17px;">MRD No: <span class="text-primary ms-1"><?php echo $mrd_no ?></span></div>                      
                      </div>
                      <div class="col-3">
                        <div class="bed-no" style="font-size: 17px;">Bed No: <span class="text-primary ms-1"><?php echo $bed_id ?></span></div>
                      </div>
                      <div class="col-3">
                        <div class="patient-name text-end" style="font-size: 17px;">Patient Name: <span class="text-primary ms-1"><?php echo $patient_name ?></span></div>
                      </div>
                          
                          
                          
                        </div>
                    </div>
                  </div>           
                  </header>
                  <div style="margin-top: 10px;" class="card-body">
    <!-- <div class="row">
        <div class="card-body">
            <div class="row ps-2">
                <div class="card-text h-full space-y-4">
                    <form id="commentForm">
                        <div class="input-area position-relative">
                            <div class="row">
                                <div >
                                    <select class="form-select" id="messageTypeSelect" name="category">
                                        <option value="Diet chart">Diet chart</option>
                                        <option value="Medicines">Medicines</option>
                                        <option value="Daily-checkup">Daily-checkup</option>
                                        <option value="Doctor comments">Doctor comments</option>
                                    </select>
                                </div>
                                <div >
                                    <textarea class="form-control" name="comment" placeholder="Enter your comment here" style="height: 200px;"></textarea>
                                </div>
                            </div>
                            <input type="hidden" name="patient_id" value="<?php echo $patient_id; ?>">
                            <input type="hidden" name="mrd_no" value="<?php echo $mrd_no; ?>">
                            <div style="text-align: right; margin-top: 10px;">
                                <button type="submit" class="btn btn-primary">Send</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div> -->
    
                        <div class="row">
                            <div class="card-body">
                                <div class="row ps-2">
                                    <div class="card-text h-full space-y-4">
                                        <form id="commentForm">
                                            <div class="input-area position-relative">
                                                <div class="row-one">
                                                  <h5>Nursing Notes</h5>
                                                <!-- <div class="input-group" style="width: 300px;">
                                                <select class="form-select" id="messageTypeSelect" name="category">
                                                    <option value="Diet chart">Diet chart</option>
                                                    <option value="Medicines">Medicines</option>
                                                    <option value="Daily-checkup">Daily-checkup</option>
                                                    <option value="Doctor comments">Doctor comments</option>
                                                </select>

                                </div> -->
                                <div class="input-group" style="height : 200px; width: 100%">
                                    <textarea class="form-control" name="comment" placeholder="Enter your comment here"></textarea>
                                </div>
                                <input type="hidden" name="patient_id" value="<?php echo $patient_id; ?>">
                                <input type="hidden" name="mrd_no" value="<?php echo $mrd_no; ?>">
                                <div style="text-align: right; margin-top: 35px;">
                                    <button type="submit" style="width: 100px;" class="btn btn-primary">Send</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
 

</div>
<div class="card-body p-6 mt-4">
    <div class="container">
        <div class="row">
            <div class="col-md-12">
            <?php if (empty($comments)): ?>
    <p style="text-align: center; margin-top: 20px;">No comments available here</p>
<?php else: ?>
    <table class="table table-bordered" style="margin-left: -12px; width: 104%;">
        <thead>
            <tr>
                <th style="width: 250px; text-align: center;">Date & Time</th>
                <th style="text-align: center;">Description</th>
            </tr>
        </thead>
        <tbody>
            <?php foreach ($comments as $comment): ?>
                <tr>
                    <td style="text-align: center;"><?php echo htmlspecialchars($comment['created_at']); ?></td>
                    <td style="padding-left: 10px;"><?php echo htmlspecialchars($comment['comment']); ?></td>
                </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
<?php endif; ?>

            </div>
        </div>
    </div>
</div>

</div>





            



                    </div>

                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- BEGIN: Footer For Desktop and tab -->
      <!-- <footer id="footer">
        <div
          class="site-footer px-6 bg-white dark:bg-slate-800 text-slate-500 dark:text-slate-300 py-4 ltr:ml-[248px] rtl:mr-[248px]">
          <div class="grid md:grid-cols-2 grid-cols-1 md:gap-5">
            <div class="text-center ltr:md:text-start rtl:md:text-right text-sm">
              COPYRIGHT ©
              <span id="thisYear"></span>
              DashCode, All rights Reserved
            </div>
            <div class="ltr:md:text-right rtl:md:text-end text-center text-sm">
              Hand-crafted &amp; Made by
              <a href="https://codeshaper.net/" target="_blank" class="text-primary-500 font-semibold">
                Codeshaper
              </a>
            </div>
          </div>
        </div>
      </footer> -->
      <!-- END: Footer For Desktop and tab -->
     
  </main>
  <!-- scripts -->

  <script src="<?php echo $main_path; ?>assets/js/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/rt-plugins.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/app.js"></script>

  <!-- Bootstrap CSS -->

  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>

<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>

<link href="<?php echo $main_path; ?>assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" rel="stylesheet" >


  <!-- Bootstrap JS and Popper.js -->
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/popperjs/popper.min.js"></script>
<script src="<?php echo $main_path; ?>assets/bootstrap/js/bootstrap.min.js"></script>
<script src="<?php echo $main_path; ?>assets/toastr/build/toastr.min.js"></script> 
<link rel="stylesheet" href="<?php echo $main_path; ?>assets/toastr/build/toastr.min.css" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>
// $(document).ready(function() {
//     // Function to fetch and display comments
//     function fetchComments() {
//         $.ajax({
//             url: '', // The same PHP file
//             method: 'GET',
//             data: { action: 'fetch_comments', patient_id: <?php echo $patient_id; ?> },
//             success: function(response) {
//                 var comments = JSON.parse(response);
//                 var commentsHtml = '';
//                 comments.forEach(function(comment) {
//                     commentsHtml += '<div><strong>' + comment.category + ':</strong><p>' + comment.comment + '</p><p><em>' + comment.created_at + '</em></p><hr></div>';
//                 });
//                 $('#data').html(commentsHtml);
//             }
//         });
//     }

//     // Initial fetch and display of comments
//     fetchComments();

//     // Form submission handling
//     $('#commentForm').on('submit', function(e) {
//         e.preventDefault();

//         var formData = $(this).serialize() + '&action=add_comment';

//         $.ajax({
//             type: 'POST',
//             url: '', // The same PHP file
//             data: formData,
//             success: function(response) {
//                 var result = JSON.parse(response);
//                 if (result.status === 'success') {
//                     // Clear the form
//                     $('#commentForm')[0].reset();

//                     // Immediately fetch and update comments
//                     fetchComments();
//                     location.reload();
//                 } else {
//                     alert('Failed to add comment.');
//                 }
//             }
//         });
//     });
// });


$(document).ready(function() {
    // Function to fetch and display comments
    function fetchComments() {
        $.ajax({
            url: '', // The same PHP file
            method: 'GET',
            data: { action: 'fetch_comments', patient_id: <?php echo $patient_id; ?> },
            success: function(response) {
                var comments = JSON.parse(response);
                var commentsHtml = '';
                // Reverse comments array to ensure new comments are at the top
                comments.reverse().forEach(function(comment) {
                    commentsHtml += '<div><strong>' + comment.category + ':</strong><p>' + comment.comment + '</p><p><em>' + comment.created_at + '</em></p><hr></div>';
                });
                $('#data').html(commentsHtml);
            }
        });
    }

    // Initial fetch and display of comments
    fetchComments();

    // Form submission handling
    $('#commentForm').on('submit', function(e) {
    e.preventDefault(); // Prevent the default form submission

    var formData = $(this).serialize();
    console.log(formData); // Log the form data to check its content

    $.ajax({
        url: '', // The same PHP file
        method: 'POST',
        data: formData,
        success: function(response) {
            var result = JSON.parse(response);
            if (result.status === 'success') {
                toastr.success('Comment added successfully');
                fetchComments(); // Refresh comments after adding
                location.reload();
            } else {
                toastr.error('Failed to add comment: ' + result.error);
            }
        },
        error: function() {
            toastr.error('An error occurred while submitting the form');
        }
    });
});

    });



</script>

</body>

</html>