<?php
  include('include.php');
?>
<!DOCTYPE html>
<html lang="zxx" dir="ltr" class="light">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <title>AARTHY HOSPITAL</title>
  <link rel="icon" type="image/png" href="<?php echo $main_path; ?>assets/images/logo/favicon.svg">
  <link rel="preconnect" href="https://fonts.googleapis.com/">
  <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;800&amp;display=swap" rel="stylesheet">
  <!-- BEGIN: Theme CSS-->
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/rt-plugins.css">
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/app.css">
  <script src="<?php echo $main_path; ?>assets/js/store.js" async></script>
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/toastr/build/toastr.min.css" />
  <style>
    tbody>tr.data-patient:hover {
      background: #efefef !important;
      cursor: pointer;
    }

    .table-td {
      text-align: center !important;
    }

    .table-th {
      text-align: center !important;
    }

    .dashcode-data-table label {
      display: inline !important;
    }

    #data-table_length,
    #data-table_filter {
      display: inline-block;
    }

    #data-table_filter {
      float: right;
      margin-bottom: 20px;
    }

    .dashcode-data-table .dataTables_info,
    .dashcode-data-table .dataTables_paginate {
      display: inline-block;
      vertical-align: middle;
    }

    .dashcode-data-table .dataTables_paginate {
      float: right;
    }

    .dashcode-data-table .dataTables_paginate a,
    .dashcode-data-table .dataTables_paginate span {
      margin: 0 5px;
      /* Adjust as needed */
    }

    .dashcode-data-table .dataTables_paginate,
    .dashcode-data-table .dataTables_info {
      margin-top: 20px;
    }

    .dataTables_info {
      display: none !important;
    }

    .drop_div {
      background: #d8d8d8;
      padding: 10px;
      border-radius: 10px;
    }

    .drop_div .patient_label {
      color: #000;
      font-size: 20px;
      font-weight: bold;
    }

    .timer {
      background: #d8d8d8;
      padding: 10px;
      border-radius: 10px;
    }

    .timer .timing {
      font-size: 60px;
      color: #000;
      font-weight: bold;
    }

    .icon-arrow.clock {
      width: 90px;
      font-size: 100px;
      background: none;
    }

    .timer-btns {
      margin: 25px 60px;
    }

    .patient_info {
      display: flex;
      flex-direction: column;
    }

    .patient_info>div {
      display: flex;
      align-items: center;
      margin-bottom: 10px;
    }

    .patient_label {
      width: 150px;
    }

    .patient_info .text {
      font-size: 16px;
      color: #000;
      font-weight: bold;
    }
  </style>
</head>
<body class="font-inter dashcode-app" id="body_class">
  <main class="app-wrapper">
    <?php include('sidebar.php'); ?>
    <div class="flex flex-col justify-between min-h-screen">
      <div>
        <?php include('nav.php'); ?>
        <!-- Modal for Creating Drip -->
        <div id="vertically_center" tabindex="-1" aria-labelledby="form_modal" aria-hidden="true" class="modal fade fixed top-0 left-0 hidden w-full h-full outline-none overflow-x-hidden overflow-y-auto">
          <div class="modal-dialog modal-md relative w-auto pointer-events-none">
            <div class="modal-content border-none shadow-lg relative flex flex-col w-full pointer-events-auto bg-white bg-clip-padding rounded-md outline-none text-current">
              <div class="relative w-full h-full max-w-xl md:h-auto">
                <div class="relative bg-white rounded-lg shadow dark:bg-slate-700">
                  <!-- Modal header -->
                  <div class="flex items-center justify-between p-5 border-b rounded-t dark:border-slate-600 bg-black-500">
                    <h3 class="text-xl font-medium text-white dark:text-white capitalize">
                      Create Drip
                    </h3>
                    <button type="button" class="text-slate-400 bg-transparent hover:bg-slate-200 hover:text-slate-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-slate-600 dark:hover:text-white" data-bs-dismiss="modal">
                      <svg aria-hidden="true" class="w-5 h-5" fill="#ffffff" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                        <path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10
                                  11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path>
                      </svg>
                      <span class="sr-only">Close modal</span>
                    </button>
                  </div>
                  <!-- Modal body -->
                  <div>
                    <div class="p-6 space-y-6">
                      <div class="input-group">
                        <label for="patient_name">Select Patient</label>
                        <div class="relative">
                          <select name="patient_name" id="patient_id" class="form-control mt-0">
                            <option value="">--- SELECT PATIENT ---</option>
                            <!-- Patient options will be dynamically populated -->
                          </select>
                        </div>
                      </div>
                      <div class="input-group">
                        <label for="drip">Select Drip</label>
                        <div class="relative">
                          <select name="drip" id="drip" class="form-control mt-0">
                            <option value="">--- SELECT DRIP ---</option>
                            <option value="1">Drip 1</option>
                            <!-- Add more drip options as needed -->
                          </select>
                        </div>
                      </div>
                      <div class="input-group">
                        <label for="start_time">Start Time</label>
                        <div class="relative">
                          <input type="time" id="start_time" class="form-control time_inpt" name="start_time" maxlength="8" placeholder="hh:mm AM/PM">
                        </div>
                      </div>
                      <div class="input-group">
                        <label for="end_time">End Time</label>
                        <div class="relative">
                          <input type="time" id="end_time" class="form-control time_inpt" maxlength="8" placeholder="hh:mm AM/PM" />
                        </div>
                      </div>
                    </div>
                    <!-- Modal footer -->
                    <div class="flex items-center justify-end p-6 space-x-2 border-t border-slate-200 rounded-b dark:border-slate-600">
                      <button data-bs-dismiss="modal" type="button" class="btn inline-flex justify-center btn-outline-dark close_modal_btn">Cancel</button>
                      <button type="button" id="set_timer" class="btn inline-flex justify-center text-white bg-black-500">Set</button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="vertically_center_modal" tabindex="-1" aria-labelledby="form_modal" aria-hidden="true" class="modal fade fixed top-0 left-0 hidden w-full h-full outline-none overflow-x-hidden overflow-y-auto">
          <div class="modal-dialog modal-md relative w-auto pointer-events-none">
            <div class="modal-content border-none shadow-lg relative flex flex-col w-full pointer-events-auto bg-white bg-clip-padding rounded-md outline-none text-current">
              <div class="relative w-full h-full max-w-xl md:h-auto">
                <div class="relative bg-white rounded-lg shadow dark:bg-slate-700">
                  <!-- Modal header -->
                  <div class="flex items-center justify-between p-5 border-b rounded-t dark:border-slate-600 bg-black-500">
                    <h3 class="text-xl font-medium text-white dark:text-white capitalize">
                      Extend Time
                    </h3>
                    <button type="button" class="text-slate-400 bg-transparent hover:bg-slate-200 hover:text-slate-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-slate-600 dark:hover:text-white" data-bs-dismiss="modal">
                      <svg aria-hidden="true" class="w-5 h-5" fill="#ffffff" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                        <path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10
                                  11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path>
                      </svg>
                      <span class="sr-only">Close modal</span>
                    </button>
                  </div>
                  <!-- Modal body -->
                  <div>
                    <div class="p-6 space-y-6">
                      
                    
                      <div class="input-group">
                        <label for="start_time">Start Time</label>
                        <div class="relative">
                          <input type="time" id="start_time" class="form-control time_inpt" name="start_time" maxlength="8" placeholder="hh:mm AM/PM">
                        </div>
                      </div>
                      <div class="input-group">
                        <label for="end_time">End Time</label>
                        <div class="relative">
                          <input type="time" id="end_time" class="form-control time_inpt" maxlength="8" placeholder="hh:mm AM/PM" />
                        </div>
                      </div>
                    </div>
                    <!-- Modal footer -->
                    <div class="flex items-center justify-end p-6 space-x-2 border-t border-slate-200 rounded-b dark:border-slate-600">
                      <button data-bs-dismiss="modal" type="button" class="btn inline-flex justify-center btn-outline-dark close_modal_btn">Cancel</button>
                      <button type="button" id="set_timer" class="btn inline-flex justify-center text-white bg-black-500">Extend</button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- End: Modal for Creating Drip -->
        <div class="content-wrapper transition-all duration-150 xl:ltr:ml-[248px] xl:rtl:mr-[248px]" id="content_wrapper">
          <div class="page-content">
            <div id="content_layout">
              <div class="grid xl:grid-cols-1 grid-cols-1 gap-6">
                <div class="card">
                  <header class="card-header noborder">
                    <h4 class="card-title">On Going Drips</h4>
                    <div>
                      <button class="btn btn-primary btn-sm" id="create_drip_btn">Create Drip +</button>
                    </div>
                  </header>
                  <div class="card-body px-6 pb-6">
                    <div class="drop_div" id="ongoing_drips_container">
                      <!-- Ongoing Drips will be dynamically appended here -->
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
  <script src="<?php echo $main_path; ?>assets/js/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/rt-plugins.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/app.js"></script>
  <script src="<?php echo $main_path; ?>assets/toastr/build/toastr.min.js"></script>
<script>
  $(document).ready(function() {
  // Function to fetch patients and populate the dropdown
  function fetchPatients() {
    $.ajax({
      url: 'ajax/drip/getPatient.php',
      type: 'GET',
      success: function(response) {
        try {
          var result = JSON.parse(response);
          if (result.status === 'Success') {
            var patients = result.data;
            var options = '';
            patients.forEach(function(patient) {
              options += `<option value="${patient.id}" data-mrd="${patient.mrd_no}">${patient.patient_name}</option>`;
            });
            $('#patient_id').html(options);
          } else {
            toastr.error('Failed to fetch patients');
          }
        } catch (error) {
          console.error('Error parsing JSON:', error);
          toastr.error('Error fetching patients');
        }
      },
      error: function(xhr, status, error) {
        console.error('Error fetching patients:', error);
        toastr.error('Error fetching patients');
      }
    });
  }
  // Function to fetch and display existing drips
  function fetchExistingDrips() {
    $.ajax({
      url: 'ajax/drip/get_drip.php',
      type: 'GET',
      dataType: 'json', // Expect JSON response
      success: function(response) {
        if (response.status === 'Success') {
          var drips = response.data;
          drips.forEach(function(drip) {
            var dripHtml = generateDripHtml(drip);
            $('#ongoing_drips_container').append(dripHtml);
            startTimer(drip); // Start the timer for each drip
          });
        } else if (response.status === 'No data') {
          toastr.info('No drips found');
        } else {
          toastr.error('Failed to fetch existing drips');
        }
      },
      error: function(xhr, status, error) {
        console.error('Error fetching existing drips:', error);
        toastr.error('Error fetching existing drips');
      }
    });
  }

  fetchPatients();
  fetchExistingDrips();
 // Function to handle click on "Create Drip" button
  $('#create_drip_btn').click(function() { 
    $('#vertically_center').modal('show'); // Show the create drip modal
  });

  // Function to handle click on "Set" button inside the create drip modal
  $('#set_timer').click(function() {
    var formData = {
      patient_name: $('#patient_id option:selected').text(), // Get the selected patient name
      patient_id: $('#patient_id').val(),
      mrd_no: $('#patient_id option:selected').data('mrd'), // Get MRD number from data attribute
      drip_id: $('#drip').val(),
      start_time: $('#start_time').val(),
      end_time: $('#end_time').val()
    };

    // Validate start time against current time
    var currentTime = new Date();
    var selectedStartTime = parseTime(formData.start_time);
    var selectedEndTime = parseTime(formData.end_time);

    if (!selectedStartTime || !selectedEndTime) {
      toastr.error('Invalid time format');
      return;
    }

    if (selectedStartTime <= currentTime) {
      toastr.error('Start time must be in the future.');
      return;
    }

    // Send AJAX request to create the drip record
    $.ajax({
      url: 'ajax/drip/create_drip.php', // Adjust the path as per your file structure
      type: 'POST',
      data: formData,
      dataType: 'json', // Expect JSON response
      success: function(response) {
        if (response.status === 'Success') {
          // Handle success, show toastr notification
          toastr.success(response.message);
          $('#vertically_center').modal('hide'); // Close modal

          // Append new drip HTML to ongoing drips container only if start time is valid
          if (selectedStartTime > currentTime) {
            var dripHtml = generateDripHtml(formData);
            $('#ongoing_drips_container').append(dripHtml);
            startTimer(formData); // Start the timer for the new drip
          }
        } else {
          // Handle error, show toastr notification
          toastr.error(response.message);
        }
      },
      error: function(xhr, status, error) {
        // Handle AJAX error, show toastr notification
        toastr.error('Failed to create drip: ' + error);
      }
    });
  });

  // Function to generate HTML for displaying a drip
  function generateDripHtml(drip) {
    var startTimeFormatted = formatTime12Hour(drip.start_time);
    var endTimeFormatted = formatTime12Hour(drip.end_time);

    // Calculate time difference
    var startTime = parseTime(drip.start_time);
    var endTime = parseTime(drip.end_time);

    if (!startTime || !endTime) {
      return ''; // Return empty string if parsing fails
    }

    var timeDiff = endTime.getTime() - startTime.getTime();

    // Convert time difference to hours, minutes, seconds
    var hours = Math.floor(timeDiff / 3600000);
    var minutes = Math.floor((timeDiff % 3600000) / 60000);
    var seconds = Math.floor((timeDiff % 60000) / 1000);
// Format the time difference as HH:MM:SS
    var timeDifference = `${hours.toString().padStart(2, '0')}:${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;
    var dripHtml = `
      <div class="row" style="margin-top:20px;">
        <div class="timing_div_append flex justify-between">
          <div class="col-lg-6 patient_info">
            <div>
              <span class="patient_label" style="font-size: 16px;">Patient Name</span>
              <span class="patient_name text">: ${drip.patient_name}</span> <!-- Placeholder for patient name -->
            </div>
            <div>
              <span class="patient_label" style="font-size: 16px;">MRD No.</span>
              <span class="patient_mrd_no text">: ${drip.mrd_no}</span> <!-- Display MRD number -->
            </div>
            <div>
              <span class="patient_label" style="font-size: 16px;">Type</span>
              <span class="patient_type text">: IP</span>
            </div>
            <div>
              <span class="patient_label" style="font-size: 16px;">Start Time</span>
              <span class="patient_start_time text">: ${startTimeFormatted}</span>
            </div>
            <div>
              <span class="patient_label" style="font-size: 16px;">End Time</span>
              <span class="patient_end_time text">: ${endTimeFormatted}</span>
            </div>
          </div>
          <div class="col-lg-6 flex justify-center items-center">
            <div class="drip_timer">
              <div class="timer flex items-center">
                <div class="clock">
                  <iconify-icon class="icon-arrow clock" style="color: #505050;" icon="mdi:stopwatch-outline"></iconify-icon>
                </div>
                <div class="timing">${timeDifference}</div> <!-- Display time difference -->
              </div>
              <div class="timer-btns flex justify-between">
                <button class="btn inline-flex justify-center btn-outline-dark add_btn" id="add_extend_time">Extend</button>
                <button class="btn btn-lg btn-light submit_btn">End</button>
              </div>
            </div>
          </div>
        </div>
      </div><hr>`;

    return dripHtml;
  }
  // Function to parse time string into Date object
  function parseTime(timeString) {
    var timeParts = timeString.split(':');
    if (timeParts.length !== 2) {
      return null;
    }
    var hours = parseInt(timeParts[0]);
    var minutes = parseInt(timeParts[1]);
    if (isNaN(hours) || isNaN(minutes)) {
      return null;
    }
    var time = new Date();
    time.setHours(hours);
    time.setMinutes(minutes);
    return time;
  }
 // Function to format time into 12-hour format
  function formatTime12Hour(time) {
    var hours24 = parseInt(time.substring(0, 2));
    var minutes = time.substring(3, 5);
    var period = (hours24 >= 12) ? 'PM' : 'AM';
    var hours12 = (hours24 > 12) ? hours24 - 12 : hours24;
    hours12 = (hours12 == 0) ? 12 : hours12;
    return `${hours12}:${minutes} ${period}`;
  }
  // Function to start the timer for a drip
  function startTimer(drip) {
    var startTime = parseTime(drip.start_time);
    var endTime = parseTime(drip.end_time);
    var timeDiff = endTime.getTime() - startTime.getTime();

    var timerElement = $(`.timing:contains("${formatTime12Hour(drip.start_time)}")`).siblings('.timing'); // Adjust selector as needed

    var interval = setInterval(function() {
      timeDiff -= 1000; // Decrement by 1 second (1000 ms)
      if (timeDiff <= 0) {
        clearInterval(interval);
        timerElement.text("00:00:00");
        toastr.info('Drip time has ended for ' + drip.patient_name);
      } else {
        var hours = Math.floor(timeDiff / 3600000);
        var minutes = Math.floor((timeDiff % 3600000) / 60000);
        var seconds = Math.floor((timeDiff % 60000) / 1000);
        var timeDifference = `${hours.toString().padStart(2, '0')}:${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;
        timerElement.text(timeDifference);
      }
    }, 1000);
  }
  $('#ongoing_drips_container').on('click', '.add_btn', function() {
    $('#vertically_center_modal').modal('show');
  });
  
});


</script>
</script>
</body>
</html>